
import java.awt.MouseInfo;
import java.awt.Point;
import java.awt.PointerInfo;
import java.awt.Toolkit;
import java.net.URL;
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.scene.Cursor;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.input.MouseEvent;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;

// }EX|C^̈ʒuێV[PX
var previousX: Number[] = [-10000, -10000, -10000, -10000, -10000];
var previousY: Number[] = [-10000, -10000, -10000, -10000, -10000];

// }EX|C^ǂC[WQ
var images: ImageView[] = for (i in [4..0 step -1]) {
    println("I {i}");
    ImageView {
        x: bind previousX[i]
        y: bind previousY[i]
        image: Image {
            url: "{__DIR__}duke{i}.gif"
        }
    }
};

var stage = Stage {
    title: "Animated Cursor Sample"
    scene: Scene {
        width: 300
        height: 300
        content: [
            Rectangle {
                // J[\\Ȃ
                // J[\̑ɃC[Wgp
                cursor: Cursor.NONE
 
                x: 20 y: 20
                width: 260 height: 260
                fill: Color.AQUAMARINE

                onMouseExited: function(event: MouseEvent) {
                    // ̈悩oC[W
                    for (image in images) {
                        image.visible = false;
                    } 
                }

                onMouseEntered: function(event: MouseEvent) {
                    // ̈ɓC[W`悷
                    for (image in images) {
                        image.visible = true;
                    } 
                }
            },
            images
        ]
    }
}

var timeline = Timeline {
    repeatCount: Timeline.INDEFINITE
    keyFrames: [
        KeyFrame {
            // 100~bƂactionR[
            time: 100ms
            
            action: function() {
                // }EX|C^̈ʒu擾
                var point:PointerInfo = MouseInfo.getPointerInfo();
                var x: Number = point.getLocation().x;
                var y: Number = point.getLocation().y;

                // }EX|C^̈ʒu[gEBhEɑ΂WȂ̂
                // [JWɕϊ
                x = x - stage.x - stage.scene.x;
                y = y - stage.y - stage.scene.y;

                // ߂̈ʒu擪ɂAŌ̈ʒup
                insert x before previousX[0];
                delete previousX[5];
                
                insert y before previousY[0];
                delete previousY[5];
            }
        }
    ]
};

// Aj[V̊Jn
timeline.play();
