
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.Scene;
import javafx.stage.Stage;
import javafx.stage.StageStyle;
import net.javainthebox.javafx.FadingApplicationBar;

var opacity = 0.0;

var stage = Stage {
    title: "Fading Image"
    style: StageStyle.TRANSPARENT
    
    scene: Scene {
        width: 300
        height: 200
        fill: null
        
        content: [
            ImageView {
                opacity: bind opacity
                image: Image {
                    url: "{__DIR__}scenery.jpg"
                }
            },
        ]
    }
};

var bar = FadingApplicationBar {
    stage: stage
};
insert bar into stage.scene.content;

Timeline {
    keyFrames: [
        KeyFrame {
            time: 0s
            values: [
                opacity => 0.0
            ]
        },
        KeyFrame {
            time: 2s
            values: [
                opacity => 1.0
            ]
        }
    ]
}.play();
